Index: sasmodels/models/parallelepiped.c
===================================================================
--- sasmodels/models/parallelepiped.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/parallelepiped.c	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -1,34 +1,8 @@
 double form_volume(double length_a, double length_b, double length_c);
-double Iq(double q, double sld, double solvent_sld, double length_a, double length_b, double length_c);
+double Iq(double q, double sld, double solvent_sld,
+    double length_a, double length_b, double length_c);
 double Iqxy(double qx, double qy, double sld, double solvent_sld,
-    double length_a, double length_b, double length_c, double theta, double phi, double psi);
-
-// From Igor library
-double _pkernel(double a, double b,double c, double ala, double alb, double alc);
-double _pkernel(double a, double b,double c, double ala, double alb, double alc){
-    double argA,argB,argC,tmp1,tmp2,tmp3;
-    //handle arg=0 separately, as sin(t)/t -> 1 as t->0
-    argA = 0.5*a*ala;
-    argB = 0.5*b*alb;
-    argC = 0.5*c*alc;
-    if(argA==0.0) {
-        tmp1 = 1.0;
-    } else {
-        tmp1 = sin(argA)*sin(argA)/argA/argA;
-    }
-    if (argB==0.0) {
-        tmp2 = 1.0;
-    } else {
-        tmp2 = sin(argB)*sin(argB)/argB/argB;
-    }
-    if (argC==0.0) {
-        tmp3 = 1.0;
-    } else {
-        tmp3 = sin(argC)*sin(argC)/argC/argC;
-    }
-    return (tmp1*tmp2*tmp3);
-
-}
-
+    double length_a, double length_b, double length_c,
+    double theta, double phi, double psi);
 
 double form_volume(double length_a, double length_b, double length_c)
@@ -45,66 +19,39 @@
     double length_c)
 {
-    double tmp1, tmp2;
-    
-    double mu = q * length_b;
+    const double mu = 0.5 * q * length_b;
     
     // Scale sides by B
-    double a_scaled = length_a / length_b;
-    double c_scaled = length_c / length_b;
+    const double a_scaled = length_a / length_b;
+    const double c_scaled = length_c / length_b;
         
-    //Order of integration
-    int nordi=76;			        
-    int nordj=76;
+    // outer integral (with gauss points), integration limits = 0, 1
+    double outer_total = 0; //initialize integral
 
-    // outer integral (with nordi gauss points), integration limits = 0, 1
-    double summ = 0; //initialize integral
+    for( int i=0; i<76; i++) {
+        const double sigma = 0.5 * ( Gauss76Z[i] + 1.0 );
+        const double mu_proj = mu * sqrt(1.0-sigma*sigma);
 
-    for( int i=0; i<nordi; i++) {
-		
-        // inner integral (with nordj gauss points), integration limits = 0, 1
-	
-        double summj = 0.0;
-	    double sigma = 0.5 * ( Gauss76Z[i] + 1.0 );		
-		
-	    for(int j=0; j<nordj; j++) {
+        // inner integral (with gauss points), integration limits = 0, 1
+        // corresponding to angles from 0 to pi/2.
+        double inner_total = 0.0;
+        for(int j=0; j<76; j++) {
+            const double uu = 0.5 * ( Gauss76Z[j] + 1.0 );
+            double sin_uu, cos_uu;
+            SINCOS(M_PI_2*uu, sin_uu, cos_uu);
+            const double si1 = sas_sinx_x(mu_proj * sin_uu * a_scaled);
+            const double si2 = sas_sinx_x(mu_proj * cos_uu);
+            inner_total += Gauss76Wt[j] * square(si1 * si2);
+        }
+        inner_total *= 0.5;
 
-            double uu = 0.5 * ( Gauss76Z[j] + 1.0 );
-            double mudum = mu * sqrt(1.0-sigma*sigma);
-	        double arg1 = 0.5 * mudum * cos(0.5*M_PI*uu);
-	        double arg2 = 0.5 * mudum * a_scaled * sin(0.5*M_PI*uu);
-            if(arg1==0.0) {
-	        tmp1 = 1.0;
-            } else {
-                tmp1 = sin(arg1)*sin(arg1)/arg1/arg1;
-            }
-            if (arg2==0.0) {
-                tmp2 = 1.0;
-            } else {
-                tmp2 = sin(arg2)*sin(arg2)/arg2/arg2;
-            }
+        const double si = sas_sinx_x(mu * c_scaled * sigma);
+        outer_total += Gauss76Wt[i] * inner_total * si * si;
+    }
+    outer_total *= 0.5;
 
-            summj += Gauss76Wt[j] * tmp1 * tmp2;
-        }
-		
-        // value of the inner integral
-        double answer = 0.5 * summj;
-
-        double arg = 0.5 * mu * c_scaled * sigma;
-        if ( arg == 0.0 ) {
-            answer *= 1.0;
-        } else {
-            answer *= sin(arg)*sin(arg)/arg/arg;
-        }
-		
-	    // sum of outer integral
-        summ += Gauss76Wt[i] * answer;
-        
-    }	
-   
-    const double vd = (sld-solvent_sld) * form_volume(length_a, length_b, length_c);
-    
-    // convert from [1e-12 A-1] to [cm-1] and 0.5 factor for outer integral
-    return 1.0e-4 * 0.5 * vd * vd * summ;
-    
+    // Multiply by contrast^2 and convert from [1e-12 A-1] to [cm-1]
+    const double V = form_volume(length_a, length_b, length_c);
+    const double drho = (sld-solvent_sld);
+    return 1.0e-4 * square(drho * V) * outer_total;
 }
 
@@ -120,49 +67,14 @@
     double psi)
 {
-    double q = sqrt(qx*qx+qy*qy);
-    double qx_scaled = qx/q;
-    double qy_scaled = qy/q;
+    double q, cos_val_a, cos_val_b, cos_val_c;
+    ORIENT_ASYMMETRIC(qx, qy, theta, phi, psi, q, cos_val_c, cos_val_b, cos_val_a);
 
-    // Convert angles given in degrees to radians
-    theta *= M_PI_180;
-    phi   *= M_PI_180;
-    psi   *= M_PI_180;
-    
-    // Parallelepiped c axis orientation
-    double cparallel_x = cos(theta) * cos(phi);
-    double cparallel_y = sin(theta);
-    
-    // Compute angle between q and parallelepiped axis
-    double cos_val_c = cparallel_x*qx_scaled + cparallel_y*qy_scaled;// + cparallel_z*qz;
-
-    // Parallelepiped a axis orientation
-    double parallel_x = -cos(phi)*sin(psi) * sin(theta)+sin(phi)*cos(psi);
-    double parallel_y = sin(psi)*cos(theta);
-    double cos_val_a = parallel_x*qx_scaled + parallel_y*qy_scaled;
-
-    // Parallelepiped b axis orientation
-    double bparallel_x = -sin(theta)*cos(psi)*cos(phi)-sin(psi)*sin(phi);
-    double bparallel_y = cos(theta)*cos(psi);
-    double cos_val_b = bparallel_x*qx_scaled + bparallel_y*qy_scaled;
-
-    // The following tests should always pass
-    if (fabs(cos_val_c)>1.0) {
-      //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-      cos_val_c = 1.0;
-    }
-    if (fabs(cos_val_a)>1.0) {
-      //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-      cos_val_a = 1.0;
-    }
-    if (fabs(cos_val_b)>1.0) {
-      //printf("parallel_ana_2D: Unexpected error: cos(alpha)>1\n");
-      cos_val_b = 1.0;
-    }
-    
-    // Call the IGOR library function to get the kernel
-    double form = _pkernel( q*length_a, q*length_b, q*length_c, cos_val_a, cos_val_b, cos_val_c);
-  
-    // Multiply by contrast^2
-    const double vd = (sld - solvent_sld) * form_volume(length_a, length_b, length_c);
-    return 1.0e-4 * vd * vd * form;
+    const double siA = sas_sinx_x(0.5*q*length_a*cos_val_a);
+    const double siB = sas_sinx_x(0.5*q*length_b*cos_val_b);
+    const double siC = sas_sinx_x(0.5*q*length_c*cos_val_c);
+    const double V = form_volume(length_a, length_b, length_c);
+    const double drho = (sld - solvent_sld);
+    const double form = V * drho * siA * siB * siC;
+    // Square and convert from [1e-12 A-1] to [cm-1]
+    return 1.0e-4 * form * form;
 }
Index: sasmodels/models/parallelepiped.py
===================================================================
--- sasmodels/models/parallelepiped.py	(revision 416f5c7f5af38d5e5d926a5b6b140a94e7e60502)
+++ sasmodels/models/parallelepiped.py	(revision 8e68ea06a7246c4bd95ce82c755719ced6fa5a60)
@@ -221,5 +221,5 @@
 # parameters for demo
 demo = dict(scale=1, background=0,
-            sld=6.3e-6, sld_solvent=1.0e-6,
+            sld=6.3, sld_solvent=1.0,
             length_a=35, length_b=75, length_c=400,
             theta=45, phi=30, psi=15,
Index: sasmodels/models/pearl_necklace.c
===================================================================
--- sasmodels/models/pearl_necklace.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/pearl_necklace.c	(revision 4b541acdec7c4de7cd7f18ff5911816123ce8333)
@@ -1,135 +1,91 @@
-double _pearl_necklace_kernel(double q, double radius, double edge_sep,
-	double thick_string, double num_pearls, double sld_pearl,
-	double sld_string, double sld_solv);
 double form_volume(double radius, double edge_sep,
-	double thick_string, double num_pearls);
-
+    double thick_string, double num_pearls);
 double Iq(double q, double radius, double edge_sep,
-	double thick_string, double num_pearls, double sld, 
-	double string_sld, double solvent_sld);
+    double thick_string, double num_pearls, double sld, 
+    double string_sld, double solvent_sld);
 
 #define INVALID(v) (v.thick_string >= v.radius || v.num_pearls <= 0)
 
 // From Igor library
-double _pearl_necklace_kernel(double q, double radius, double edge_sep, double thick_string,
-	double num_pearls, double sld_pearl, double sld_string, double sld_solv)
+static double
+_pearl_necklace_kernel(double q, double radius, double edge_sep, double thick_string,
+    double num_pearls, double sld_pearl, double sld_string, double sld_solv)
 {
-	//relative slds
-	double contrast_pearl = sld_pearl - sld_solv;
-	double contrast_string = sld_string - sld_solv;
-	
-	// number of string segments
-	num_pearls = floor(num_pearls + 0.5); //Force integer number of pearls
-	double num_strings = num_pearls - 1.0;
-	
-	//Pi
-	double pi = 4.0*atan(1.0);
-	
-	// center to center distance between the neighboring pearls
-	double A_s = edge_sep + 2.0 * radius;
-	
-	// Repeated Calculations
-	double sincasq = sinc(q*A_s);
-	double oneminussinc = 1 - sincasq;
-	double q_r = q * radius;
-	double q_edge = q * edge_sep;
-	
-	// each volume
-	double string_vol = edge_sep * pi * thick_string * thick_string / 4.0;
-	double pearl_vol = 4.0 / 3.0 * pi * radius * radius * radius;
+    // number of string segments
+    num_pearls = floor(num_pearls + 0.5); //Force integer number of pearls
+    const double num_strings = num_pearls - 1.0;
 
-	//total volume
-	double tot_vol;
-	//each masses
-	double m_r= contrast_string * string_vol;
-	double m_s= contrast_pearl * pearl_vol;
-	double psi, gamma, beta;
-	//form factors
-	double sss, srr, srs; //cross
-	double srr_1, srr_2, srr_3;
-	double form_factor;
-	tot_vol = num_strings * string_vol;
-	tot_vol += num_pearls * pearl_vol;
+    //each masses: contrast * volume
+    const double contrast_pearl = sld_pearl - sld_solv;
+    const double contrast_string = sld_string - sld_solv;
+    const double string_vol = edge_sep * M_PI_4 * thick_string * thick_string;
+    const double pearl_vol = M_4PI_3 * radius * radius * radius;
+    const double m_string = contrast_string * string_vol;
+    const double m_pearl = contrast_pearl * pearl_vol;
 
-	//sine functions of a pearl
-	psi = sin(q_r);
-	psi -= q_r * cos(q_r);
-	psi *= 3.0;
-	psi /= q_r * q_r * q_r;
+    // center to center distance between the neighboring pearls
+    const double A_s = edge_sep + 2.0 * radius;
 
-	// Note take only 20 terms in Si series: 10 terms may be enough though.
-	gamma = Si(q_edge);
-	gamma /= (q_edge);
-	beta = Si(q * (A_s - radius));
-	beta -= Si(q_r);
-	beta /= q_edge;
+    //sine functions of a pearl
+    // Note: lim_(q->0) Si(q*a)/(q*b) = a/b
+    // So therefore:
+    //    beta = q==0. ? 1.0 : (Si(q*(A_s-radius)) - Si(q*radius))/q_edge;
+    //    gamma = q==0. ? 1.0 : Si(q_edge)/q_edge;
+    // But there is a 1/(1-sinc) term below which blows up so don't bother
+    const double q_edge = q * edge_sep;
+    const double beta = (sas_Si(q*(A_s-radius)) - sas_Si(q*radius)) / q_edge;
+    const double gamma = sas_Si(q_edge) / q_edge;
+    const double psi = sas_3j1x_x(q*radius);
 
-	// form factor for num_pearls
-	sss = 1.0 - pow(sincasq, num_pearls);
-	sss /= oneminussinc * oneminussinc;
-	sss *= -sincasq;
-	sss -= num_pearls / 2.0;
-	sss += num_pearls / oneminussinc;
-	sss *= 2.0 * m_s * psi * m_s * psi;
+    // Precomputed sinc terms
+    const double si = sas_sinx_x(q*A_s);
+    const double omsi = 1.0 - si;
+    const double pow_si = pow(si, num_pearls);
 
-	// form factor for num_strings (like thin rods)
-	srr_1 = -sinc(q_edge/2.0) * sinc(q_edge/2.0);
+    // form factor for num_pearls
+    const double sss = 2.0*square(m_pearl*psi) * (
+        - si * (1.0 - pow_si) / (omsi*omsi)
+        + num_pearls / omsi
+        - 0.5 * num_pearls
+        );
 
-	srr_1 += 2.0 * gamma;
-	srr_1 *= num_strings;
-	srr_2 = 2.0/oneminussinc;
-	srr_2 *= num_strings;
-	srr_2 *= beta * beta;
-	srr_3 = 1.0 - pow(sincasq, num_strings);
-	srr_3 /= oneminussinc * oneminussinc;
-	srr_3 *= beta * beta;
-	srr_3 *= -2.0;
+    // form factor for num_strings (like thin rods)
+    const double srr = m_string * m_string * (
+        - 2.0 * (1.0 - pow_si/si)*beta*beta / (omsi*omsi)
+        + 2.0 * num_strings*beta*beta / omsi
+        + num_strings * (2.0*gamma - square(sas_sinx_x(q_edge/2.0)))
+        );
 
-	// total srr
-	srr = srr_1 + srr_2 + srr_3;
-	srr *= m_r * m_r;
+    // form factor for correlations
+    const double srs = 4.0 * m_string * m_pearl * beta * psi * (
+        - si * (1.0 - pow_si/si) / (omsi*omsi)
+        + num_strings / omsi
+        );
 
-	// form factor for correlations
-	srs = 1.0;
-	srs -= pow(sincasq, num_strings);
-	srs /= oneminussinc * oneminussinc;
-	srs *= -sincasq;
-	srs += num_strings/oneminussinc;
-	srs *= 4.0;
-	srs *= (m_r * m_s * beta * psi);
+    const double form = sss + srr + srs;
 
-	form_factor = sss + srr + srs;
-	form_factor /= (tot_vol * 1.0e4); // norm by volume and A^-1 to cm^-1
-
-	return (form_factor);
+    return 1.0e-4 * form;
 }
 
 double form_volume(double radius, double edge_sep,
-	double thick_string, double num_pearls)
+    double thick_string, double num_pearls)
 {
-	double total_vol;
+    num_pearls = floor(num_pearls + 0.5); //Force integer number of pearls
 
-	double pi = 4.0*atan(1.0);
-	double number_of_strings = num_pearls - 1.0;
-	
-	double string_vol = edge_sep * pi * thick_string * thick_string / 4.0;
-	double pearl_vol = 4.0 / 3.0 * pi * radius * radius * radius;
+    const double num_strings = num_pearls - 1.0;
+    const double string_vol = edge_sep * M_PI_4 * thick_string * thick_string;
+    const double pearl_vol = M_4PI_3 * radius * radius * radius;
+    const double volume = num_strings*string_vol + num_pearls*pearl_vol;
 
-	total_vol = number_of_strings * string_vol;
-	total_vol += num_pearls * pearl_vol;
-
-	return(total_vol);
+    return volume;
 }
 
 double Iq(double q, double radius, double edge_sep,
-	double thick_string, double num_pearls, double sld, 
-	double string_sld, double solvent_sld)
+    double thick_string, double num_pearls, double sld, 
+    double string_sld, double solvent_sld)
 {
-	double value, tot_vol;
-	
-	value = _pearl_necklace_kernel(q, radius, edge_sep, thick_string,
-		num_pearls, sld, string_sld, solvent_sld);
-	tot_vol = form_volume(radius, edge_sep, thick_string, num_pearls);
+    const double form = _pearl_necklace_kernel(q, radius, edge_sep,
+        thick_string, num_pearls, sld, string_sld, solvent_sld);
 
-	return value*tot_vol;
+    return form;
 }
Index: sasmodels/models/pearl_necklace.py
===================================================================
--- sasmodels/models/pearl_necklace.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/pearl_necklace.py	(revision 4b541acdec7c4de7cd7f18ff5911816123ce8333)
@@ -92,5 +92,5 @@
              ]
 
-source = ["lib/Si.c", "pearl_necklace.c"]
+source = ["lib/sas_Si.c", "lib/sas_3j1x_x.c", "pearl_necklace.c"]
 single = False  # use double precision unless told otherwise
 
@@ -112,5 +112,5 @@
     """
     tot_vol = volume(radius, edge_sep, thick_string, num_pearls)
-    rad_out = pow((3.0*tot_vol/4.0/pi), 0.33333)
+    rad_out = (tot_vol/(4.0/3.0*pi)) ** (1./3.)
     return rad_out
 
Index: sasmodels/models/poly_gauss_coil.py
===================================================================
--- sasmodels/models/poly_gauss_coil.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/poly_gauss_coil.py	(revision f0afad25082efbba5303001a106a13ea6a36c1c1)
@@ -59,5 +59,6 @@
 """
 
-from numpy import inf, exp, power
+import numpy as np
+from numpy import inf, expm1, power
 
 name = "poly_gauss_coil"
@@ -83,14 +84,27 @@
     # pylint: disable = missing-docstring
     u = polydispersity - 1.0
-    z = (q*rg)**2 / (1.0 + 2.0*u)
+    z = q**2 * (rg**2 / (1.0 + 2.0*u))
+
     # need to trap the case of the polydispersity being 1 (ie, monodisperse!)
     if polydispersity == 1.0:
-        inten = i_zero * 2.0 * (exp(-z) + z - 1.0)
+        result = 2.0 * (expm1(-z) + z)
+        index = q != 0.
+        result[index] /= z[index]**2
+        result[~index] = 1.0
     else:
-        inten = i_zero * 2.0 * (power(1.0 + u*z, -1.0/u) + z - 1.0) / (1.0 + u)
-    index = q != 0.
-    inten[~index] = i_zero
-    inten[index] /= z[index]**2
-    return inten
+        # Taylor series around z=0 of (2*(1+uz)^(-1/u) + z - 1) / (z^2(u+1))
+        p = [
+            #(-1 - 20*u - 155*u**2 - 580*u**3 - 1044*u**4 - 720*u**5) / 2520.,
+            #( 1 + 14*u + 71*u**2 + 154*u**3 + 120*u**4) / 360.,
+            #(-1 - 9*u - 26*u**2 - 24*u**3) / 60.,
+            ( 1 + 5*u + 6*u**2) / 12.,
+            (-1 - 2*u) / 3.,
+            ( 1 ),
+            ]
+        result = 2.0 * (power(1.0 + u*z, -1.0/u) + z - 1.0) / (1.0 + u)
+        index = z > 1e-4
+        result[index] /= z[index]**2
+        result[~index] = np.polyval(p, z[~index])
+    return i_zero * result
 Iq.vectorized = True  # Iq accepts an array of q values
 
Index: sasmodels/models/polymer_micelle.c
===================================================================
--- sasmodels/models/polymer_micelle.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/polymer_micelle.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -31,9 +31,9 @@
 
     // Self-correlation term of the core
-    const double bes_core = sph_j1c(q*radius_core);
-    const double term1 = n_aggreg*n_aggreg*beta_core*beta_core*bes_core*bes_core;
+    const double bes_core = sas_3j1x_x(q*radius_core);
+    const double term1 = square(n_aggreg*beta_core*bes_core);
 
     // Self-correlation term of the chains
-    const double qrg2 = q*rg*q*rg;
+    const double qrg2 = square(q*rg);
     const double debye_chain = (qrg2 == 0.0) ? 1.0 : 2.0*(expm1(-qrg2)+qrg2)/(qrg2*qrg2);
     const double term2 = n_aggreg * beta_corona * beta_corona * debye_chain;
@@ -41,11 +41,11 @@
     // Interference cross-term between core and chains
     const double chain_ampl = (qrg2 == 0.0) ? 1.0 : -expm1(-qrg2)/qrg2;
-    const double bes_corona = sinc(q*(radius_core + d_penetration * rg));
-    const double term3 = 2 * n_aggreg * n_aggreg * beta_core * beta_corona *
+    const double bes_corona = sas_sinx_x(q*(radius_core + d_penetration * rg));
+    const double term3 = 2.0 * n_aggreg * n_aggreg * beta_core * beta_corona *
                  bes_core * chain_ampl * bes_corona;
 
     // Interference cross-term between chains
-    const double term4 = n_aggreg * (n_aggreg - 1.0) * beta_corona * beta_corona *
-                 chain_ampl * chain_ampl * bes_corona * bes_corona;
+    const double term4 = n_aggreg * (n_aggreg - 1.0)
+                 * square(beta_corona * chain_ampl * bes_corona);
 
     // I(q)_micelle : Sum of 4 terms computed above
Index: sasmodels/models/polymer_micelle.py
===================================================================
--- sasmodels/models/polymer_micelle.py	(revision bba9361c45987d76f3673d7d0a4eb16d28a8b701)
+++ sasmodels/models/polymer_micelle.py	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -104,5 +104,5 @@
 single = False
 
-source = ["lib/sph_j1c.c", "polymer_micelle.c"]
+source = ["lib/sas_3j1x_x.c", "polymer_micelle.c"]
 
 demo = dict(scale=1, background=0,
Index: sasmodels/models/porod.py
===================================================================
--- sasmodels/models/porod.py	(revision 40a87fa5096610e24c3ead10299f609e99f093f2)
+++ sasmodels/models/porod.py	(revision 4962519cc1910422a467e4f643dba223623e0e09)
@@ -41,5 +41,5 @@
     """
     with errstate(divide='ignore'):
-        return power(q, -4)
+        return q**-4
 
 Iq.vectorized = True  # Iq accepts an array of q values
Index: sasmodels/models/pringle.c
===================================================================
--- sasmodels/models/pringle.c	(revision 30fbe2eda4d6f97acc840bd5e605de3829caf3c7)
+++ sasmodels/models/pringle.c	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -91,5 +91,5 @@
         SINCOS(psi, sin_psi, cos_psi);
         double bessel_term = _sum_bessel_orders(radius, alpha, beta, q*sin_psi, q*cos_psi);
-        double sinc_term = square(sinc(q * thickness * cos_psi / 2.0));
+        double sinc_term = square(sas_sinx_x(q * thickness * cos_psi / 2.0));
         double pringle_kernel = 4.0 * sin_psi * bessel_term * sinc_term;
         sum += Gauss76Wt[i] * pringle_kernel;
Index: sasmodels/models/raspberry.c
===================================================================
--- sasmodels/models/raspberry.c	(revision 2c74c11fc4544381ecf9949bd1618c67ff624c6d)
+++ sasmodels/models/raspberry.c	(revision 925ad6edca2969db8fb763eb02beee2c5a5f2872)
@@ -51,11 +51,11 @@
 
     //Form factors for each particle
-    psiL = sph_j1c(q*rL);
-    psiS = sph_j1c(q*rS);
+    psiL = sas_3j1x_x(q*rL);
+    psiS = sas_3j1x_x(q*rS);
 
     //Cross term between large and small particles
-    sfLS = psiL*psiS*sinc(q*(rL+deltaS*rS));
+    sfLS = psiL*psiS*sas_sinx_x(q*(rL+deltaS*rS));
     //Cross term between small particles at the surface
-    sfSS = psiS*psiS*sinc(q*(rL+deltaS*rS))*sinc(q*(rL+deltaS*rS));
+    sfSS = psiS*psiS*sas_sinx_x(q*(rL+deltaS*rS))*sas_sinx_x(q*(rL+deltaS*rS));
 
     //Large sphere form factor term
Index: sasmodels/models/raspberry.py
===================================================================
--- sasmodels/models/raspberry.py	(revision 40a87fa5096610e24c3ead10299f609e99f093f2)
+++ sasmodels/models/raspberry.py	(revision 8e68ea06a7246c4bd95ce82c755719ced6fa5a60)
@@ -129,5 +129,5 @@
             Ref: J. coll. inter. sci. (2010) vol. 343 (1) pp. 36-41."""
 category = "shape:sphere"
-#single = False
+
 
 #             [ "name", "units", default, [lower, upper], "type", "description"],
@@ -152,5 +152,5 @@
              ]
 
-source = ["lib/sph_j1c.c", "raspberry.c"]
+source = ["lib/sas_3j1x_x.c", "raspberry.c"]
 
 # parameters for demo
Index: sasmodels/models/rectangular_prism.c
===================================================================
--- sasmodels/models/rectangular_prism.c	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/rectangular_prism.c	(revision 1e7b0db0b7b4315c62b59e1d659332bcbc962b8f)
@@ -2,6 +2,4 @@
 double Iq(double q, double sld, double solvent_sld, double length_a, 
           double b2a_ratio, double c2a_ratio);
-double Iqxy(double qx, double qy, double sld, double solvent_sld, 
-            double length_a, double b2a_ratio, double c2a_ratio);
 
 double form_volume(double length_a, double b2a_ratio, double c2a_ratio)
@@ -17,58 +15,41 @@
     double c2a_ratio)
 {
-    double termA, termB, termC;
-    
-    double b_side = length_a * b2a_ratio;
-    double c_side = length_a * c2a_ratio;
-    double volume = length_a * b_side * c_side;
-    double a_half = 0.5 * length_a;
-    double b_half = 0.5 * b_side;
-    double c_half = 0.5 * c_side;
+    const double length_b = length_a * b2a_ratio;
+    const double length_c = length_a * c2a_ratio;
+    const double a_half = 0.5 * length_a;
+    const double b_half = 0.5 * length_b;
+    const double c_half = 0.5 * length_c;
 
    //Integration limits to use in Gaussian quadrature
-    double v1a = 0.0;
-    double v1b = 0.5 * M_PI;  //theta integration limits
-    double v2a = 0.0;
-    double v2b = 0.5 * M_PI;  //phi integration limits
+    const double v1a = 0.0;
+    const double v1b = M_PI_2;  //theta integration limits
+    const double v2a = 0.0;
+    const double v2b = M_PI_2;  //phi integration limits
     
-    //Order of integration
-    int nordi=76;			        
-    int nordj=76;
+    double outer_sum = 0.0;
+    for(int i=0; i<76; i++) {
+        const double theta = 0.5 * ( Gauss76Z[i]*(v1b-v1a) + v1a + v1b );
+        double sin_theta, cos_theta;
+        SINCOS(theta, sin_theta, cos_theta);
 
-    double sumi = 0.0;
-    
-    for(int i=0; i<nordi; i++) {
+        const double termC = sas_sinx_x(q * c_half * cos_theta);
 
-	    double theta = 0.5 * ( Gauss76Z[i]*(v1b-v1a) + v1a + v1b );	
+        double inner_sum = 0.0;
+        for(int j=0; j<76; j++) {
+            double phi = 0.5 * ( Gauss76Z[j]*(v2b-v2a) + v2a + v2b );
+            double sin_phi, cos_phi;
+            SINCOS(phi, sin_phi, cos_phi);
 
-	    double arg = q * c_half * cos(theta);
-	    if (fabs(arg) > 1.e-16) {termC = sin(arg)/arg;} else {termC = 1.0;}  
-
-	    double sumj = 0.0;
-        
-	    for(int j=0; j<nordj; j++) {
-
-            double phi = 0.5 * ( Gauss76Z[j]*(v2b-v2a) + v2a + v2b ); 
-
-	        // Amplitude AP from eqn. (12), rewritten to avoid round-off effects when arg=0
-
-	        arg = q * a_half * sin(theta) * sin(phi); 
-	        if (fabs(arg) > 1.e-16) {termA = sin(arg)/arg;} else {termA = 1.0;}
-	       
-	        arg = q * b_half * sin(theta) * cos(phi); 
-	        if (fabs(arg) > 1.e-16) {termB = sin(arg)/arg;} else {termB = 1.0;}	  
-               
-	        double AP = termA * termB * termC;  
-
-	        sumj += Gauss76Wt[j] * (AP*AP);
-
-	    }
-
-	    sumj = 0.5 * (v2b-v2a) * sumj;
-	    sumi += Gauss76Wt[i] * sumj * sin(theta);
-
+            // Amplitude AP from eqn. (12), rewritten to avoid round-off effects when arg=0
+            const double termA = sas_sinx_x(q * a_half * sin_theta * sin_phi);
+            const double termB = sas_sinx_x(q * b_half * sin_theta * cos_phi);
+            const double AP = termA * termB * termC;
+            inner_sum += Gauss76Wt[j] * AP * AP;
+        }
+        inner_sum = 0.5 * (v2b-v2a) * inner_sum;
+        outer_sum += Gauss76Wt[i] * inner_sum * sin_theta;
     }
 
-    double answer = 0.5*(v1b-v1a)*sumi;
+    double answer = 0.5*(v1b-v1a)*outer_sum;
 
     // Normalize by Pi (Eqn. 16). 
@@ -77,8 +58,9 @@
     // The factor 2 appears because the theta integral has been defined between 
     // 0 and pi/2, instead of 0 to pi.
-    answer *= (2.0/M_PI); //Form factor P(q)
+    answer /= M_PI_2; //Form factor P(q)
 
     // Multiply by contrast^2 and volume^2
-    answer *= (sld-solvent_sld)*(sld-solvent_sld)*volume*volume;
+    const double volume = length_a * length_b * length_c;
+    answer *= square((sld-solvent_sld)*volume);
 
     // Convert from [1e-12 A-1] to [cm-1] 
@@ -86,16 +68,3 @@
 
     return answer;
-    
 }
-
-double Iqxy(double qx, double qy,
-    double sld,
-    double solvent_sld,
-    double length_a,
-    double b2a_ratio,
-    double c2a_ratio)
-{
-    double q = sqrt(qx*qx + qy*qy);
-    double intensity = Iq(q, sld, solvent_sld, length_a, b2a_ratio, c2a_ratio); 
-    return intensity;    
-}
Index: sasmodels/models/rectangular_prism.py
===================================================================
--- sasmodels/models/rectangular_prism.py	(revision a8072067ae8a224e45d23ba71f663aadbe1ba4a9)
+++ sasmodels/models/rectangular_prism.py	(revision ab2aea81f7fb392e5f24f1c76dd989914d8f7022)
@@ -3,12 +3,12 @@
 r"""
 
-This model provides the form factor, *P(q)*, for a rectangular prism.
+This model provides the form factor, $P(q)$, for a rectangular prism.
 
 Note that this model is almost totally equivalent to the existing
 :ref:`parallelepiped` model.
 The only difference is that the way the relevant
-parameters are defined here (*a*, *b/a*, *c/a* instead of *a*, *b*, *c*)
+parameters are defined here ($a$, $b/a$, $c/a$ instead of $a$, $b$, $c$)
 which allows use of polydispersity with this model while keeping the shape of
-the prism (e.g. setting *b/a* = 1 and *c/a* = 1 and applying polydispersity
+the prism (e.g. setting $b/a = 1$ and $c/a = 1$ and applying polydispersity
 to *a* will generate a distribution of cubes of different sizes).
 Note also that, contrary to :ref:`parallelepiped`, it does not compute
@@ -24,5 +24,5 @@
 Note also that the angle definitions used in the code and the present
 documentation correspond to those used in (Nayuk, 2012) (see Fig. 1 of
-that reference), with |theta| corresponding to |alpha| in that paper,
+that reference), with $\theta$ corresponding to $\alpha$ in that paper,
 and not to the usual convention used for example in the
 :ref:`parallelepiped` model. As the present model does not compute
@@ -30,17 +30,20 @@
 
 In this model the scattering from a massive parallelepiped with an
-orientation with respect to the scattering vector given by |theta|
-and |phi|
+orientation with respect to the scattering vector given by $\theta$
+and $\phi$
 
 .. math::
-  A_P\,(q) =  \frac{\sin \bigl( q \frac{C}{2} \cos\theta \bigr)}{\left( q \frac{C}{2}
-  \cos\theta \right)} \, \times \, \frac{\sin \bigl( q \frac{A}{2} \sin\theta \sin\phi
-  \bigr)}{\left( q \frac{A}{2} \sin\theta \sin\phi \right)} \, \times \, \frac{\sin \bigl(
-  q \frac{B}{2} \sin\theta \cos\phi \bigr)}{\left( q \frac{B}{2} \sin\theta \cos\phi \right)}
 
-where *A*, *B* and *C* are the sides of the parallelepiped and must fulfill
-:math:`A \le B \le C`, |theta| is the angle between the *z* axis and the
-longest axis of the parallelepiped *C*, and |phi| is the angle between the
-scattering vector (lying in the *xy* plane) and the *y* axis.
+  A_P\,(q) =
+      \frac{\sin \left( \tfrac{1}{2}qC \cos\theta \right) }{\tfrac{1}{2} qC \cos\theta}
+      \,\times\,
+      \frac{\sin \left( \tfrac{1}{2}qA \cos\theta \right) }{\tfrac{1}{2} qA \cos\theta}
+      \,\times\ ,
+      \frac{\sin \left( \tfrac{1}{2}qB \cos\theta \right) }{\tfrac{1}{2} qB \cos\theta}
+
+where $A$, $B$ and $C$ are the sides of the parallelepiped and must fulfill
+$A \le B \le C$, $\theta$ is the angle between the $z$ axis and the
+longest axis of the parallelepiped $C$, and $\phi$ is the angle between the
+scattering vector (lying in the $xy$ plane) and the $y$ axis.
 
 The normalized form factor in 1D is obtained averaging over all possible
@@ -48,5 +51,5 @@
 
 .. math::
-  P(q) =  \frac{2}{\pi} \times \, \int_0^{\frac{\pi}{2}} \,
+  P(q) =  \frac{2}{\pi} \int_0^{\frac{\pi}{2}} \,
   \int_0^{\frac{\pi}{2}} A_P^2(q) \, \sin\theta \, d\theta \, d\phi
 
@@ -54,9 +57,9 @@
 
 .. math::
-  I(q) = \mbox{scale} \times V \times (\rho_{\mbox{p}} -
-  \rho_{\mbox{solvent}})^2 \times P(q)
+  I(q) = \text{scale} \times V \times (\rho_\text{p} -
+  \rho_\text{solvent})^2 \times P(q)
 
-where *V* is the volume of the rectangular prism, :math:`\rho_{\mbox{p}}`
-is the scattering length of the parallelepiped, :math:`\rho_{\mbox{solvent}}`
+where $V$ is the volume of the rectangular prism, $\rho_\text{p}$
+is the scattering length of the parallelepiped, $\rho_\text{solvent}$
 is the scattering length of the solvent, and (if the data are in absolute
 units) *scale* represents the volume fraction (which is unitless).
@@ -125,5 +128,5 @@
 # parameters for demo
 demo = dict(scale=1, background=0,
-            sld=6.3e-6, sld_solvent=1.0e-6,
+            sld=6.3, sld_solvent=1.0,
             length_a=35, b2a_ratio=1, c2a_ratio=1,
             length_a_pd=0.1, length_a_pd_n=10,
